<?php


namespace app\api\controller;


use app\common\model\WechatConfig;
use app\common\util\wechat\WechatMpSDK;
use EasyWeChat\Factory;
use think\facade\Log;
use think\facade\View;

class WechatMpAuth extends Base
{

    /**
     * 测试例子
     * http://local74.lzj/yc_api/api/public/index.php/api/wechat_mp_auth/test1
     */
    public function test1()
    {
        $callback = (string)url("WechatMpAuth/test2", ["testParam" => "hello"], '', true);
        $toUrl = (string)url("WechatMpAuth/authorize", ['remark' => '备注1', 'wechatcode' => 'test1', 'callback' => urlencode2($callback)], '', true);
        var_dump($toUrl);
        header("Location:$toUrl");
        //http://local74.lzj/yc_api/api/public/index.php/api/WechatMpAuth/authorize?remark=test1&wechatcode=test1&callback=http%25253A%25252F%25252Flocal74.lzj%25252Fyc_api%25252Fapi%25252Fpublic%25252Findex.php%25252Fapi%25252FWechatMpAuth%25252Ftest2%25253FtestParam%25253Dhello
    }

    public function test2()
    {
        echo "this is callback\n<br/>";
        $param = request()->param();
        $userInfo = json_decode(base64_decode(input("userinfo")), true);
        print_r($param);
        print_r($userInfo);

    }

    public function authorize()
    {
        $param = request()->param();
        $rules = [
            "callback|回调地址" => "require",
            "wechatcode|微信代码" => "require",
        ];
        $this->autoValid($rules, $param);
        $callback = trim(urldecode2(input("callback")));//回调地址
        $scope = input("scope", "snsapi_userinfo");//snsapi_userinfo   snsapi_base
        $remark = trim(urldecode2(input("remark", "")));//input("remark", "");//备注
        $method = input("method", "post");//回调方式
        $wechatcode = input("wechatcode");
        $wechatConfig = WechatConfig::getEasyWechatConfig($wechatcode);
        Log::record("wechatConfig:" . json_encode($wechatConfig, JSON_UNESCAPED_UNICODE), "debug");
        $app = Factory::officialAccount($wechatConfig);
        $param = [
            "callback" => urlencode2($callback),
            "remark" => urlencode2($remark),
            "method" => $method,
            "wechatcode" => $wechatcode,
        ];
        $callback2 = (string)url('WechatMpAuth/callback', $param, "", true);
        $response = $app->oauth->scopes([$scope])->redirect($callback2);
        header("Location:$response");
        return "";
        //print_r($response);
//        $response->send();
    }

    //http://local74.lzj/yc_api/api/public/index.php/api/WechatMpAuth/callback?callback=http%25253A%25252F%25252Flocal74.lzj%25252Fyc_api%25252Fapi%25252Fpublic%25252Findex.php%25252Fapi%25252FWechatMpAuth%25252Ftest2%25253FtestParam%25253Dhello&remark=test1&method=get&wechatcode=test1&code=011yLJ0w3kHLUY2cNF0w3w46qC2yLJ0m&state=6047de6f5bb28ccf632790e56bf614ac
    public function callback()
    {
        $param = request()->param();
        $callback = trim(urldecode2(input("callback")));
        $method = input("method", "post");
        $remark = input("remark", "");
        View::assign("method", $method);
        View::assign("callback", $callback);
        View::assign("remark", $remark);
        $wechatcode = input("wechatcode");
        View::assign("wechatcode", $wechatcode);
        $wechatConfig = WechatConfig::getEasyWechatConfig($wechatcode);
        Log::record("wechatConfig:" . json_encode($wechatConfig, JSON_UNESCAPED_UNICODE), "debug");
        $app = Factory::officialAccount($wechatConfig);
        $oauth = $app->oauth;
        $code = input("code");
        $user = $oauth->userFromCode($code);
        Log::record("user:" . json_encode($user, JSON_UNESCAPED_UNICODE), "debug");
        $userArray = [
            'openid' => $user->getId(),
            'nickname' => $user->getNickname(),
            'name' => $user->getNickname(),
            'avatar' => $user->getAvatar(),
            'raw' => $user->getRaw(),
        ];
        Log::record("userArray:" . json_encode($userArray, JSON_UNESCAPED_UNICODE), "debug");
        $userJson = json_encode($userArray, JSON_UNESCAPED_UNICODE);
        $userinfo = base64_encode($userJson);
        Log::record("userinfo base64:" . $userinfo, "debug");
        View::assign("userinfo", $userinfo);
        if (strtolower($method) == "get") {
            $callback = $this->urlAddParam($callback, "remark", $remark);
            $callback = $this->urlAddParam($callback, "wechatcode", $wechatcode);
            $callback = $this->urlAddParam($callback, "userinfo", $userinfo);
            header("Location:$callback");
            return "";
        }
        return View::fetch();
    }

    private function urlAddParam($url, $key, $value)
    {
        if (strpos($url, "?") === false) {
            $url .= "?$key=" . $value;
        } else {
            $url .= "&$key=" . $value;
        }
        return $url;
    }
}